package model;

import java.util.ArrayList;

public class Pawn extends Piece {
	public Pawn(Position p, int color) {
		super(p, color);
	}

	public ArrayList<Position> getAvailableMoves(Board b) {

		// creates a dynamic list of available moves
		ArrayList<Position> moves = new ArrayList<>();
		Position arrival;

		int y = -1;
		if(color == Piece.WHITE) { // black and white have an opposite direction behavior
			y = 1;
		}

		// forward
		arrival = new Position(p.getX(), p.getY() + y);
		if(b.isFree(arrival)) {
			moves.add(arrival);
			// forward twice, only if it's first move
			if(!hasBeenMoved){
				arrival = new Position(p.getX(), p.getY() + y + y);
				if(b.isFree(arrival)) { moves.add(arrival); }
			}
		}

		// forward + east, attack-only movement
		arrival = new Position(p.getX() + 1, p.getY() + y);
		if(b.isEnemy(arrival, p)) { moves.add(arrival); }

		// forward + west, attack-only movement
		arrival = new Position(p.getX() - 1, p.getY() + y);
		if(b.isEnemy(arrival, p)) { moves.add(arrival); }

		return moves;
	}
}

